using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using Syncfusion.Grouping;
using Syncfusion.Web.UI.WebControls.Tools;
using Syncfusion.Web.UI.WebControls;
using System.Data.SqlClient;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using System.Drawing;

public partial class _Default : System.Web.UI.Page 
{
    private string bindVal;
    protected void Page_Init(object sender, EventArgs e)
    {
        if (!Page.IsPostBack == true)
        {
            Session["StRowIndex"] = 0;
            this.GridGroupingControl1.DataSourceControlRowDeleting += new GridDataSourceControlRowDeleteEventHandler(this.RowDeleting);
            this.GridGroupingControl1.DataSourceControlRowAdding += new GridDataSourceControlRowAddingEventHandler(this.RowAdding);
            this.GridGroupingControl1.DataSourceControlRowUpdating += new GridDataSourceControlRowUpdateEventHandler(this.RowUpdating);
        }
        string stRow = Session["stRowIndex"].ToString();
        //We bind the grid in this method.
        if (stRow != "")
        {
           //Avoid rebinding
            bindVal = stRow;
            BindGrid(); 
        }
   }
    protected void BindGrid()
    {
        this.GridGroupingControl1.DataSource = null;
        this.GridGroupingControl1.DataSource = this.odsProducts;
        GridTableDescriptor maintd = this.GridGroupingControl1.TableDescriptor;
        // Calling ResetTableDescriptor is the best way to reset all settings in the TableDescriptor.    // Setting like user's sorted columns,    
        maintd.ResetTableDescriptor();
        this.GridGroupingControl1.TableDescriptor.PrimaryKeyColumns.Add("id");
        this.GridGroupingControl1.DataBind();
        //Make FormEditMode as DefaultForm UI for Editing
        GridGroupingControl1.TableDescriptor.FormEditMode = TableEditMode.UseDefaultForm;
    }

    protected void NextBtn_Click(object sender, EventArgs e)
    {
        int nextSetVal = (int)Session["StRowIndex"];
        nextSetVal = nextSetVal + 5;
        ProductsList prList = new ProductsList();
        if (nextSetVal < prList.GetRowsCount())
        {
            Session["StRowIndex"] = nextSetVal;
        }
        BindGrid();
    }

    protected void PrevBtn_Click(object sender, EventArgs e)
    {
        int nextSetVal = (int)Session["StRowIndex"];
        nextSetVal = nextSetVal - 5;
        if (nextSetVal < 0)
        {
            Session["StRowIndex"] = 0;
        }
        else
        {
            Session["StRowIndex"] = nextSetVal;
        }
        BindGrid();
    }

    protected void odsProducts_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.Arguments.StartRowIndex = (int)Session["StRowIndex"];
        //Consider the pageSize is 5
        e.Arguments.MaximumRows = 5;
    }

    #region Prevent updation in datasource
    private void RowUpdating(object sender, GridDataSourceControlRowUpdateEventArgs e)
    {
        e.Cancel = true;
    }
    private void RowAdding(object sender, GridDataSourceControlRowAddingEventArgs e)
    {
        e.Cancel = true;
    }

    private void RowDeleting(object sender, GridDataSourceControlRowDeleteEventArgs e)
    {
        e.Cancel = true;
    }
    #endregion

    protected void LinkButton1_Click(object sender, EventArgs e)
    {
        //We dont check for sorted columns names here, just clearing the previous sorted columns.
        this.GridGroupingControl1.TableDescriptor.SortedColumns.Clear();
         SortColumnDescriptor scd =new SortColumnDescriptor();
        scd.Name="Name";
        if(scd.SortDirection==ListSortDirection.Ascending)
        {
        scd.SortDirection=ListSortDirection.Descending;
        }
        else
        {
        scd.SortDirection=ListSortDirection.Ascending;
        }
        this.GridGroupingControl1.TableDescriptor.SortedColumns.Add(scd);
    }
    protected void LinkButton4_Click(object sender, EventArgs e)
    {

        GridSortColumnDescriptor gscd=new GridSortColumnDescriptor();
        gscd.Name="Name";
        this.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Clear();
        this.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Add(gscd);
    }
    protected void LinkButton5_Click(object sender, EventArgs e)
    {
        SortColumnDescriptor scd =new SortColumnDescriptor();
        scd.Name = "Freight";
        if(scd.SortDirection==ListSortDirection.Ascending)
        {
        scd.SortDirection=ListSortDirection.Descending;
        }
        else
        {
        scd.SortDirection=ListSortDirection.Ascending;
        }
        //We used this to avoid exception when trying to sorting the same column.
        this.GridGroupingControl1.TableDescriptor.SortedColumns.Clear();
        //Adding a sorted column.
        this.GridGroupingControl1.TableDescriptor.SortedColumns.Add(scd);
    }
    protected void LinkButton8_Click(object sender, EventArgs e)
    {
        //this clears all column's grouping 
        GridSortColumnDescriptor gscd=new GridSortColumnDescriptor();
        gscd.Name="Freight";
        //we remove the grouping if it is already grouped, you can check this by getting 
        //all the grouped columns from the collection and also can remove. if needed.
        
        this.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Remove(gscd);
        this.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Add(gscd);
    }
    //Ungrouping the category column by clicking the link button.
    protected void LbCategoryUnGroup_Click(object sender, EventArgs e)
    {
       //this clears all column's grouping 
        GridSortColumnDescriptor gscd = new GridSortColumnDescriptor();
        gscd.Name = "Name";
        //we remove the grouping if it is already grouped, you can check this by getting 
        //all the grouped columns from the collection and also can remove. if needed.
        try
        {
            this.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Remove(gscd);
        }
        catch
        {
        }
     }
    protected void Page_Load(object sender, EventArgs e)
    {
        string stRow = Session["stRowIndex"].ToString();
        //avoid rebind if no change in value.
        if (stRow != "" && bindVal != stRow)
        {
            BindGrid(); 
        }
         
    }
    protected void Button5_Click(object sender, EventArgs e)
    {
        Record rec = this.GridGroupingControl1.Table.CurrentRecord;
        Label1.Text = rec.GetValue("id").ToString();    
    }
    protected void btnEdit_Click(object sender, EventArgs e)
    {
        Record rec = this.GridGroupingControl1.Table.CurrentRecord;
        rec.BeginEdit();

    }
}
