Imports Microsoft.VisualBasic
Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.ComponentModel
Imports Syncfusion.Grouping
Imports Syncfusion.Web.UI.WebControls.Tools
Imports Syncfusion.Web.UI.WebControls
Imports System.Data.SqlClient
Imports Syncfusion.Web.UI.WebControls.Grid.Grouping
Imports System.Drawing

Public partial Class _Default : Inherits System.Web.UI.Page
	Private bindVal As String
	Protected Sub Page_Init(ByVal sender As Object, ByVal e As EventArgs)
		If (Not Page.IsPostBack) = True Then
			Session("StRowIndex") = 0
			Me.GridGroupingControl1.DataSourceControlRowDeleting += New GridDataSourceControlRowDeleteEventHandler(Me.RowDeleting)
			Me.GridGroupingControl1.DataSourceControlRowAdding += New GridDataSourceControlRowAddingEventHandler(Me.RowAdding)
			Me.GridGroupingControl1.DataSourceControlRowUpdating += New GridDataSourceControlRowUpdateEventHandler(Me.RowUpdating)
		End If
		Dim stRow As String = Session("stRowIndex").ToString()
		'We bind the grid in this method.
		If stRow <> "" Then
		   'Avoid rebinding
			bindVal = stRow
			BindGrid()
		End If
	End Sub
	Protected Sub BindGrid()
		Me.GridGroupingControl1.DataSource = Nothing
		Me.GridGroupingControl1.DataSource = Me.odsProducts
		Dim maintd As GridTableDescriptor = Me.GridGroupingControl1.TableDescriptor
		' Calling ResetTableDescriptor is the best way to reset all settings in the TableDescriptor.    // Setting like user's sorted columns,    
		maintd.ResetTableDescriptor()
		Me.GridGroupingControl1.TableDescriptor.PrimaryKeyColumns.Add("id")
		Me.GridGroupingControl1.DataBind()
		'Make FormEditMode as DefaultForm UI for Editing
		GridGroupingControl1.TableDescriptor.FormEditMode = TableEditMode.UseDefaultForm
	End Sub

	Protected Sub NextBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim nextSetVal As Integer = CInt(Session("StRowIndex"))
		nextSetVal = nextSetVal + 5
		Dim prList As ProductsList = New ProductsList()
		If nextSetVal < prList.GetRowsCount() Then
			Session("StRowIndex") = nextSetVal
		End If
		BindGrid()
	End Sub

	Protected Sub PrevBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim nextSetVal As Integer = CInt(Session("StRowIndex"))
		nextSetVal = nextSetVal - 5
		If nextSetVal < 0 Then
			Session("StRowIndex") = 0
		Else
			Session("StRowIndex") = nextSetVal
		End If
		BindGrid()
	End Sub

	Protected Sub odsProducts_Selecting(ByVal sender As Object, ByVal e As ObjectDataSourceSelectingEventArgs)
		e.Arguments.StartRowIndex = CInt(Session("StRowIndex"))
		'Consider the pageSize is 5
		e.Arguments.MaximumRows = 5
	End Sub

	#Region "Prevent updation in datasource"
	Private Sub RowUpdating(ByVal sender As Object, ByVal e As GridDataSourceControlRowUpdateEventArgs)
		e.Cancel = True
	End Sub
	Private Sub RowAdding(ByVal sender As Object, ByVal e As GridDataSourceControlRowAddingEventArgs)
		e.Cancel = True
	End Sub

	Private Sub RowDeleting(ByVal sender As Object, ByVal e As GridDataSourceControlRowDeleteEventArgs)
		e.Cancel = True
	End Sub
	#End Region

	Protected Sub LinkButton1_Click(ByVal sender As Object, ByVal e As EventArgs)
		'We dont check for sorted columns names here, just clearing the previous sorted columns.
		Me.GridGroupingControl1.TableDescriptor.SortedColumns.Clear()
		 Dim scd As SortColumnDescriptor = New SortColumnDescriptor()
		scd.Name="Name"
		If scd.SortDirection=ListSortDirection.Ascending Then
		scd.SortDirection=ListSortDirection.Descending
		Else
		scd.SortDirection=ListSortDirection.Ascending
		End If
		Me.GridGroupingControl1.TableDescriptor.SortedColumns.Add(scd)
	End Sub
	Protected Sub LinkButton4_Click(ByVal sender As Object, ByVal e As EventArgs)

		Dim gscd As GridSortColumnDescriptor = New GridSortColumnDescriptor()
		gscd.Name="Name"
		Me.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Clear()
		Me.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Add(gscd)
	End Sub
	Protected Sub LinkButton5_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim scd As SortColumnDescriptor = New SortColumnDescriptor()
		scd.Name = "Freight"
		If scd.SortDirection=ListSortDirection.Ascending Then
		scd.SortDirection=ListSortDirection.Descending
		Else
		scd.SortDirection=ListSortDirection.Ascending
		End If
		'We used this to avoid exception when trying to sorting the same column.
		Me.GridGroupingControl1.TableDescriptor.SortedColumns.Clear()
		'Adding a sorted column.
		Me.GridGroupingControl1.TableDescriptor.SortedColumns.Add(scd)
	End Sub
	Protected Sub LinkButton8_Click(ByVal sender As Object, ByVal e As EventArgs)
		'this clears all column's grouping 
		Dim gscd As GridSortColumnDescriptor = New GridSortColumnDescriptor()
		gscd.Name="Freight"
		'we remove the grouping if it is already grouped, you can check this by getting 
		'all the grouped columns from the collection and also can remove. if needed.

		Me.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Remove(gscd)
		Me.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Add(gscd)
	End Sub
	'Ungrouping the category column by clicking the link button.
	Protected Sub LbCategoryUnGroup_Click(ByVal sender As Object, ByVal e As EventArgs)
	   'this clears all column's grouping 
		Dim gscd As GridSortColumnDescriptor = New GridSortColumnDescriptor()
		gscd.Name = "Name"
		'we remove the grouping if it is already grouped, you can check this by getting 
		'all the grouped columns from the collection and also can remove. if needed.
		Try
			Me.GridGroupingControl1.TableDescriptor.GridGroupedColumns.Remove(gscd)
		Catch
		End Try
	End Sub
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		Dim stRow As String = Session("stRowIndex").ToString()
		'avoid rebind if no change in value.
		If stRow <> "" AndAlso bindVal <> stRow Then
			BindGrid()
		End If

	End Sub
	Protected Sub Button5_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim rec As Record = Me.GridGroupingControl1.Table.CurrentRecord
		Label1.Text = rec.GetValue("id").ToString()
	End Sub
	Protected Sub btnEdit_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim rec As Record = Me.GridGroupingControl1.Table.CurrentRecord
		rec.BeginEdit()

	End Sub
End Class
